<?php 
require_once("icwfData.inc.php");
require_once("FormValidation.inc.php");

class Country implements icwfData {
  private static $noExport = array();
  private static $notInArray = array("validation");
  private $validation;
  
  private $country_id;
  private $country;
  
  /////////////////////////////////////////////////////////////////////////////////////////////////
  // initialize
  private function initialize() {
    foreach ($this as $key => $value)
      $this->$key = null;
  }
  
  public function __construct(FormValidation $validation=null) {
    $this->initialize();
    
    $this->validation = $validation;
  }

  /////////////////////////////////////////////////////////////////////////////////////////////////
  // get values
  public function __get($name) {
    if($name == "id") $name = "country_id";
    if (array_key_exists($name, get_class_vars(get_class())) && !in_array($name, self::$noExport))
      return $this->$name;
      
    return null;
  }

  public function getIDName() {
    return "country_id";
  }
  
  public function toArray() {
    $array = array();
    foreach ($this as $key => $value)
      if(!in_array($key, self::$notInArray))
        $array[$key] = $value; 
    return $array;
  }
  
  public function getPostBackData() {
    return array($this->getIDName()=>$this->id);
  }
  
  /////////////////////////////////////////////////////////////////////////////////////////////////
  // set values
  public function setValidation(FormValidation $validation) {
    $this->$validation = $validation;
  }

  public function fromArray($array) {
    foreach ($this as $key => $value) {
      switch ($key) {
        case "validation":
          break;
          
        case "country_id":
          if(isset($array[$key]) && preg_match('~^[0-9]+$~', $array[$key]))
            $this->$key = $array[$key];
          break;
        case "country":
        default:
          if(isset($array[$key]))
            $this->$key = $array[$key];
          break;
      }
    }
    return $this->validation->validate($array);
  }
  
  /////////////////////////////////////////////////////////////////////////////////////////////////
  // database operations - read
  public function readData(DbConnection $DB, $conditions) {
    if(is_array($conditions)) {
      $whereConditions = array();
      foreach ($conditions as $key => $value)
        if(array_key_exists($key, get_class_vars(get_class())))
          $whereConditions[] = "$key=$value";
      $conditions =  implode(" AND ", $whereConditions);
    }
    $result = $DB->query("SELECT * FROM countries WHERE {$conditions};");
    
    if(!$DB->errno() && $DB->num_rows($result)>0) {
      $group = $DB->fetch_array($result);
      foreach ($group as $property => $value)
        if(property_exists($this, $property))
          $this->$property = $value;
      
      return array(0, "");
    }
    else
      return array($DB->errno(), $DB->error());
  }
  
  static public function readList(DbConnection $DB) {
    $result = $DB->query("SELECT country_id id, country name FROM countries ORDER BY country;");
    
    $list = array();
    while ($admin = $DB->fetch_array($result))
      $list[] = $admin;
      
    return $list;
  }

  /////////////////////////////////////////////////////////////////////////////////////////////////
  // database operations - write
  public function writeData(DbConnection $DB) {
    if(!isset($this->country) || !$this->country) return;
    if(isset($this->country_id) && $this->country_id) {
      $result = $DB->query("UPDATE countries SET
          country='{$this->country}'
        WHERE country_id='{$this->country_id}';");
    }
    else {
      $result = $DB->query("INSERT INTO countries(
          country
        ) VALUES(
          '{$this->country}'
        );");
      
      $this->country_id = $DB->insert_id();
    }
    return array($DB->errno(), $DB->error());
  }

  static public function deleteData(DbConnection $DB, $id) {
    if(!preg_match("~^[0-9]+$~", $id))
      return array(1, "ID not valid.");

    $result = $DB->query("DELETE FROM countries WHERE country_id='{$id}';");
    
    if(!$DB->errno() && $DB->affected_rows()>0)
      return array(0, "");
    else 
      return array($DB->errno(), $DB->error());
  }
  
  /////////////////////////////////////////////////////////////////////////////////////////////////
  // database operations - misc
  static public function createTable(DbConnection $DB) {
    $result = $DB->query("
      CREATE TABLE countries (
        country_id int unsigned NOT NULL AUTO_INCREMENT PRIMARY KEY,
        country text
      );");
    if ($result) { 
      echo _("&nbsp;&nbsp;- creating table").": 'countries'.<br>\n"; 
      echo _("&nbsp;&nbsp;- creating countries.")."<br>\n";
    }
    else { echo _("&nbsp;&nbsp;<b>- Error when creating table</b>")." 'countries'<br>\n"; $error = 1; }
  }
}
?>