<?php

class autoloader {
  public static $instance;
  private $_src=array('cwf/', 'lib/');
  private $_ext=array('.inc.php');
   
  /* initialize the autoloader class */
  public static function init(){
    if(self::$instance==NULL){
      self::$instance=new self();
    }
    return self::$instance;
  }
   
  /* put the custom functions in the autoload register when the class is initialized */
  private function __construct(){
    if(defined("AUTOLOADER_SRC")) $this->_src = explode(PATH_SEPARATOR, AUTOLOADER_SRC);
    spl_autoload_register(array($this, 'clean'));
    spl_autoload_register(array($this, 'dirty'));
  }
   
  /* the clean method to autoload the class without any includes, works in most cases */
  private function clean($class){
    $class=str_replace('_', '/', $class);
    spl_autoload_extensions(implode(',', $this->_ext));
    spl_autoload($class);
  }
   
  /* the dirty method to autoload the class after including the php file containing the class */
  private function dirty($class){
    $class=str_replace('_', '/', $class);
    foreach($this->_ext as $ext){
      @require($class . $ext);
    }
    spl_autoload($class);
  }
}
?>
